<template>
  <div>
    <!--引用表格-->
    <BasicTable @register="registerTable" :rowSelection="rowSelection">
      <!--插槽:table标题-->
      <template #tableTitle>
        <a-button type="primary" @click="handleAdd" preIcon="ant-design:plus-outlined"> 新增</a-button>
        <a-button type="primary" preIcon="ant-design:export-outlined" @click="onExportXls"> 导出</a-button>
        <j-upload-button type="primary" preIcon="ant-design:import-outlined" @click="onImportXls">导入</j-upload-button>
        <a-dropdown v-if="selectedRowKeys.length > 0">
          <template #overlay>
            <a-menu>
              <a-menu-item key="1" @click="batchHandleDelete">
                <Icon icon="ant-design:delete-outlined" />
                删除
              </a-menu-item>
            </a-menu>
          </template>
          <a-button
            >批量操作
            <Icon icon="mdi:chevron-down" />
          </a-button>
        </a-dropdown>
      </template>
      <!--操作栏-->
      <template #action="{ record }">
        <TableAction :actions="getTableAction(record)" :dropDownActions="getDropDownAction(record)" />
      </template>
    </BasicTable>
    <!-- 表单区域 -->
    <StProblemCheckModal @register="registerModal" @success="handleSuccess" />
    <!-- 整改计划 -->
    <StProblemCheckPlanModal @register="registerPlanModal" @success="handleSuccess" />
    <!-- 整改执行 -->
    <StProblemCheckExecuteModal @register="registerExecuteModal" @success="handleSuccess" />
    <!-- 整改审核 -->
    <StProblemCheckReviewModal @register="registerReviewModal" @success="handleSuccess" />
    <!-- <StProblemCheckFlowModal ref="refStProblemCheckFlow" /> -->
  </div>
</template>

<script lang="ts" name="problem-stProblemCheck" setup>
  import { ref, computed, unref } from 'vue';
  import { BasicTable, useTable, TableAction } from '/@/components/Table';
  import { useModal } from '/@/components/Modal';
  import { useListPage } from '/@/hooks/system/useListPage';
  import StProblemCheckModal from './components/StProblemCheckModal.vue';
  import { columns, searchFormSchema } from './StProblemCheck.data';
  import { list, deleteOne, batchDelete, getImportUrl, getExportUrl } from './StProblemCheck.api';
  import { downloadFile } from '/@/utils/common/renderUtils';
  import StProblemCheckPlanModal from './components/StProblemCheckPlanModal.vue';
  import StProblemCheckExecuteModal from './components/StProblemCheckExecuteModal.vue';
  import StProblemCheckReviewModal from './components/StProblemCheckReviewModal.vue';
  import StProblemCheckFlowModal from './components/StProblemCheckFlowModal.vue';
  import { store } from '/@/store';
  import { definitionStartByDeployId } from "/@/components/Process/api/definition"

  import { useRoute } from 'vue-router';
  const route = useRoute();
  


  const checkedKeys = ref<Array<string | number>>([]);
  //注册model
  const [registerModal, { openModal }] = useModal();
  const [registerPlanModal, { openModal: openPlanModal }] = useModal();
  const [registerExecuteModal, { openModal: openExecuteModal }] = useModal();
  const [registerReviewModal, { openModal: openReviewModal }] = useModal();
  //注册table数据
  const { prefixCls, tableContext, onExportXls, onImportXls } = useListPage({
    tableProps: {
      title: '问题整改',
      api: list,
      columns,
      canResize: false,
      formConfig: {
        //labelWidth: 120,
        schemas: searchFormSchema,
        autoSubmitOnEnter: true,
        showAdvancedButton: true,
        fieldMapToNumber: [],
        fieldMapToTime: [],
      },
      beforeFetch(params) {
          params['id'] = route.query.id
      },
      actionColumn: {
        width: 400,
        fixed: 'right',
      },
    },
    exportConfig: {
      name: '问题整改',
      url: getExportUrl,
    },
    importConfig: {
      url: getImportUrl,
      success: handleSuccess,
    },
  });

  const [registerTable, { reload }, { rowSelection, selectedRowKeys }] = tableContext;

  /**
   * 新增事件
   */
  function handleAdd() {
    openModal(true, {
      isUpdate: false,
      showFooter: true,
    });
  }
  /**
   * 编辑事件
   */
  function handleEdit(record: Recordable) {
    openModal(true, {
      record,
      isUpdate: true,
      showFooter: true,
    });
  }
  function handlePlan(record: Recordable) {
    openPlanModal(true, {
      record,
      isUpdate: true,
      showFooter: true,
    });
  }
  function handleExecute(record: Recordable) {
    openExecuteModal(true, {
      record,
      isUpdate: true,
      showFooter: true,
    });
  }
  function handleReview(record: Recordable) {
    openReviewModal(true, {
      record,
      isUpdate: true,
      showFooter: true,
    });
  }
  /**
   * 详情
   */
  function handleDetail(record: Recordable) {
    openModal(true, {
      record,
      isUpdate: true,
      showFooter: false,
    });
  }
  /**
   * 删除事件
   */
  async function handleDelete(record) {
    await deleteOne({ id: record.id }, handleSuccess);
  }
  /**
   * 批量删除事件
   */
  async function batchHandleDelete() {
    await batchDelete({ ids: selectedRowKeys.value }, handleSuccess);
  }
  /**
   * 成功回调
   */
  function handleSuccess() {
    (selectedRowKeys.value = []) && reload();
  }
  /**
   * 操作栏
   */
  function getTableAction(record) {
    return [
      {
        label: '编辑',
        onClick: handleEdit.bind(null, record),
      },
      {
        label: '启动流程',
        onClick: handleFlow.bind(null, record),
        ifShow: ()=> { 
            if(record['bpmStatus']==null||record['bpmStatus']=='')
            return  true
            else return false
        }
      },
      {
        label: '整改计划',
        onClick: handlePlan.bind(null, record),
      },
      {
        label: '整改执行',
        onClick: handleExecute.bind(null, record),
      },
      {
        label: '整改审核',
        onClick: handleReview.bind(null, record),
      },
    ];
  }
  /**
   * 下拉操作栏
   */
  function getDropDownAction(record) {
    return [
      {
        label: '详情',
        onClick: handleDetail.bind(null, record),
      },
      {
        label: '删除',
        popConfirm: {
          title: '是否确认删除',
          confirm: handleDelete.bind(null, record),
        },
      },
    ];
  }
  
  const formData = ref<any>({}) // 填写的表单数据
  const refStProblemCheckFlow = ref();
  function handleFlow(record: Recordable) {
    formData.dataId=record.id;
    formData.dataName='id';
    definitionStartByDeployId(record.deployId, formData).then(res => {
      console.log("计划启动----------- res",res);
      handleSuccess();   
    })

  }


</script>

<style scoped></style>
